import { EntityRepository, Repository } from "typeorm";
import { UpdateDiscoverCmsDto } from "./dto/update-discover-cms.dto";
import { DiscoverCms } from "./entities/discover-cms.entity";

@EntityRepository(DiscoverCms)
export class DiscoverCmsRepository extends Repository<DiscoverCms> {

    async createEntity(dto: UpdateDiscoverCmsDto): Promise<DiscoverCms | Error> {
        try {
            const entity = this.create({
                sectionOneHeader: dto.sectionOneHeader,
                sectionOneTitle: dto.sectionOneTitle,
                sectionOneSubTitle: dto.sectionOneSubTitle,
                sectionTwoHeader: dto.sectionTwoHeader,
                sectionTwoTitle: dto.sectionTwoTitle,
                sectionTwoSubTitle: dto.sectionTwoSubTitle,
                sectionTwoDescription: dto.sectionTwoDescription,
                sectionTwoButtonText: dto.sectionTwoButtonText,
                sectionTwoButtonLink: dto.sectionTwoButtonLink
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateDiscoverCmsDto, id: string): Promise<DiscoverCms | Error> {
        try {
            await this.update(id, {
                sectionOneHeader: dto.sectionOneHeader,
                sectionOneTitle: dto.sectionOneTitle,
                sectionOneSubTitle: dto.sectionOneSubTitle,
                sectionTwoHeader: dto.sectionTwoHeader,
                sectionTwoTitle: dto.sectionTwoTitle,
                sectionTwoSubTitle: dto.sectionTwoSubTitle,
                sectionTwoDescription: dto.sectionTwoDescription,
                sectionTwoButtonText: dto.sectionTwoButtonText,
                sectionTwoButtonLink: dto.sectionTwoButtonLink
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<DiscoverCms[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}