import { EntityRepository, Repository } from "typeorm";
import { UpdateHighDealsCmsDto } from "./dto/update-high-deals-cms.dto";
import { HighDealsCms } from "./entities/high-deals-cms.entity";

@EntityRepository(HighDealsCms)
export class HighDealsCmsRepository extends Repository<HighDealsCms> {

    async createEntity(dto: UpdateHighDealsCmsDto): Promise<HighDealsCms | Error> {
        try {
            const entity = this.create({
                titleOne: dto.titleOne,
                titleTwo: dto.titleTwo,
                subTitle: dto.subTitle,
                buttonText: dto.buttonText,
                buttonLink: dto.buttonLink
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateHighDealsCmsDto, id: string): Promise<HighDealsCms | Error> {
        try {
            await this.update(id, {
                titleOne: dto.titleOne,
                titleTwo: dto.titleTwo,
                subTitle: dto.subTitle,
                buttonText: dto.buttonText,
                buttonLink: dto.buttonLink
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<HighDealsCms[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}