import { Module } from '@nestjs/common';
import { SectionOneService } from './section-one.service';
import { SectionOneController } from './section-one.controller';
import { JwtModule } from "@nestjs/jwt";
import JwtConfigService from "src/core/jwt/jwt-config.service";
import { TypeOrmModule } from "@nestjs/typeorm";
import { UsersRepository } from "src/modules/users/user.repository";
import JwtHelper from "src/core/jwt/jwt.helper";
import { SectionOneRepository } from "./section-one.repository";
import { DoSpacesService } from "src/modules/SpacesModule/SpacesService/doSpacesService";
import { DoSpacesServicerovider } from "src/modules/SpacesModule/SpacesService";

@Module({
    imports: [
        JwtModule.registerAsync({
            useClass: JwtConfigService
        }),
        TypeOrmModule.forFeature([UsersRepository]),
        TypeOrmModule.forFeature([SectionOneRepository])
    ],
    controllers: [SectionOneController],
    providers: [SectionOneService, JwtHelper, DoSpacesService, DoSpacesServicerovider]
})
export class SectionOneModule {  }
