import { EntityRepository, Repository } from "typeorm";
import { SectionOneDto } from "./dto/section-one.dto";
import { SectionOne } from "./entities/section-one.entity";

@EntityRepository(SectionOne)
export class SectionOneRepository extends Repository<SectionOne> {

    async createEntity(dto: SectionOneDto): Promise<SectionOne | Error> {
        try {
            const entity = this.create({...dto});
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: SectionOneDto, id: string): Promise<SectionOne | Error> {
        try {
            await this.update(id, {...dto});
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<SectionOne[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}