import { EntityRepository, Repository } from "typeorm";
import { SectionThreeDto } from "./dto/section-three.dto";
import { SectionThree } from "./entities/section-three.entity";

@EntityRepository(SectionThree)
export class SectionThreeRepository extends Repository<SectionThree> {

    async createEntity(dto: SectionThreeDto): Promise<SectionThree | Error> {
        try {
            const entity = this.create({...dto});
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: SectionThreeDto, id: string): Promise<SectionThree | Error> {
        try {
            await this.update(id, {...dto});
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<SectionThree[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}