import { Module } from '@nestjs/common';
import { SectionTwoBottomService } from './section-two-bottom.service';
import { SectionTwoBottomController } from './section-two-bottom.controller';
import { JwtModule } from "@nestjs/jwt";
import JwtConfigService from "src/core/jwt/jwt-config.service";
import { TypeOrmModule } from "@nestjs/typeorm";
import { UsersRepository } from "src/modules/users/user.repository";
import { SectionTwoBottomRepository } from "./section-two-bottom.repository";
import JwtHelper from "src/core/jwt/jwt.helper";

@Module({
    imports: [
        JwtModule.registerAsync({
            useClass: JwtConfigService
        }),
        TypeOrmModule.forFeature([UsersRepository]),
        TypeOrmModule.forFeature([SectionTwoBottomRepository])
    ],
    controllers: [SectionTwoBottomController],
    providers: [SectionTwoBottomService, JwtHelper]
})
export class SectionTwoBottomModule {  }
