import { Injectable } from "@nestjs/common";
import {
    addItemToCheckout,
    createCheckout,
    fetchCartDetails,
    removeItemFromCheckout,
    updateQuantity
} from "src/helper/dutchie-plus-query";
import { getGraphQLClient } from "src/helper/graphql-client-helper";

@Injectable()
export class CheckoutService {
    async createCheckout(variables: any) {
        try {
            const graphQLClient = getGraphQLClient();
            const query = createCheckout();
            const data = await graphQLClient.request(query, variables);
            return data;
        } catch (e) {
            return e;
        }
    }

    async addItemToCheckout(variables: any) {
        try {
            const graphQLClient = getGraphQLClient();
            const query = addItemToCheckout();
            const data = await graphQLClient.request(query, variables);
            return data;
        } catch (e) {
            return e;
        }
    }

    async removeItemFromCheckout(variables: any) {
        try {
            const graphQLClient = getGraphQLClient();
            const query = removeItemFromCheckout();
            const data = await graphQLClient.request(query, variables);
            return data;
        } catch (e) {
            return e;
        }
    }


    async updateQuantity(variables: any) {
        try {
            const graphQLClient = getGraphQLClient();
            const query = updateQuantity();
            const data = await graphQLClient.request(query, variables);
            return data;
        } catch (e) {
            return e;
        }
    }

    async fetchCartDetails(variables: any) {
        try {
            const graphQLClient = getGraphQLClient();
            const query = fetchCartDetails();
            const data = await graphQLClient.request(query, variables);
            return data;
        } catch (e) {
            return e;
        }
    }
}
