import { Module } from "@nestjs/common";
import { JwtModule } from "@nestjs/jwt";
import { TypeOrmModule } from "@nestjs/typeorm";
import JwtConfigService from "src/core/jwt/jwt-config.service";
import JwtHelper from "src/core/jwt/jwt.helper";
import { AboutPageSectionTwoRepository } from "../about-page-section-two/about-page-section-two.repository";
import { AuthService } from "../auth/auth.service";
import { CareerRepository } from "../career/career.repository";
import { ChangePasswordTokenRepository } from "../change-password-token/change-password-token.repository";
import { AboutPageCmsRepository } from "../CMS/about-page-cms/about-page-cms.repository";
import { CareerPageCmsRepository } from "../CMS/career-page-cms/career-page-cms.repository";
import { ContactPageCmsRepository } from "../CMS/contact-page-cms/contact-page-cms.repository";
import { FAQPageCmsRepository } from "../CMS/faq-page-cms/faq-page-cms.repository";
import { FooterCmsRepository } from "../CMS/footer-cms/footer-cms.repository";
import {
    HomePageCommonBannerCmsRepository
} from "../CMS/home-page-common-banner-cms/home-page-common-banner-cms.repository";
import {
    HomePageSectionFourCmsRepository
} from "../CMS/home-page-section-four-cms/home-page-section-four-cms.repository";
import {
    HomePageSectionSevenCmsRepository
} from "../CMS/home-page-section-seven-cms/home-page-section-seven-cms.repository";
import {
    HomePageSectionThreeCmsRepository
} from "../CMS/home-page-section-three-cms/home-page-section-three-cms.repository";
import { HomePageSectionTwoCmsRepository } from "../CMS/home-page-section-two-cms/home-page-section-two-cms.repository";
import { NewDropBannerCmsRepository } from "../CMS/new-drop-banner-cms/new-drop-banner-cms.repository";
import { PressReleaseCmsRepository } from "../CMS/press-release-cms/press-release-cms.repository";
import { EmailNotifierRepository } from "../email-notifier/email-notifier-repository";
import { FAQRepository } from "../faq/faq.repository";
import { HomePageSectionOneRepository } from "../home-page-section-one/home-page-section-one.repository";
import { MailSenderService } from "../mail-sender/mail-sender.service";
import { SocialPackRepository } from "../social-pack/social-pack.repository";
import { UsersRepository } from "../users/user.repository";
import { SiteFrontendController } from "./site-frontend.controller";
import { SiteFrontendService } from "./site-frontend.service";
import { PressReleaseRepository } from "../press-release/press-release.repository";
import { ArticlePageCmsRepository } from "../CMS/article-page-cms/article-page-cms.repository";
import { BlogPostRepository } from "../blog/blog-post/blog-post.repository";
import { BlogCategoryRepository } from "../blog/blog-category/blog-category.repository";
import { BlogTagRepository } from "../blog/blog-tag/blog-tag.repository";
import { CareerDepartmentRepository } from "../career-department/career-department.repository";
import { BlogPostTagsRepository } from "../blog/blog-post-tags/blog-post-tags.repository";
import { BlogRelatedPostsRepository } from "../blog/blog-related-posts/blog-related-posts.repository";
import { QuizRepository } from "../quiz/quiz.repository";
import { QuizPageCmsRepository } from "../CMS/quiz-page-cms/quiz-page-cms.repository";
import { CareerApplicantRepository } from "../career-applicant/career-applicant.repository";
import { ContactMessageRepository } from "../contact-message/contact-message.repository";
import { FeedbackRepository } from "../feedback/feedback.repository";
import { RetailerService } from "../dutchie-plus/retailer/retailer.service";
import { RetailerServiceRepository } from "../retailer-service/retailer-service.repository";
import { AlpineiqService } from "../alpineiq/alpineiq.service";
import { PageTitleCmsRepository } from "../CMS/page-title-cms/page-title-cms.repository";

@Module({
    imports: [
        JwtModule.registerAsync({
            useClass: JwtConfigService
        }),
        TypeOrmModule.forFeature([UsersRepository]),
        TypeOrmModule.forFeature([ChangePasswordTokenRepository]),
        TypeOrmModule.forFeature([
            EmailNotifierRepository,
            AboutPageCmsRepository,
            AboutPageSectionTwoRepository,
            HomePageCommonBannerCmsRepository,
            NewDropBannerCmsRepository,
            HomePageSectionThreeCmsRepository,
            ContactPageCmsRepository,
            FAQPageCmsRepository,
            FAQRepository,
            SocialPackRepository,
            FooterCmsRepository,
            CareerPageCmsRepository,
            CareerRepository,
            HomePageSectionOneRepository,
            HomePageSectionTwoCmsRepository,
            HomePageSectionFourCmsRepository,
            HomePageSectionSevenCmsRepository,
            PressReleaseCmsRepository,
            PressReleaseRepository,
            ArticlePageCmsRepository,
            BlogPostRepository,
            BlogCategoryRepository,
            BlogTagRepository,
            CareerDepartmentRepository,
            BlogPostTagsRepository,
            BlogRelatedPostsRepository,
            QuizRepository,
            QuizPageCmsRepository,
            CareerApplicantRepository,
            ContactMessageRepository,
            FeedbackRepository,
            RetailerServiceRepository,
            PageTitleCmsRepository
        ])
    ],
    controllers: [SiteFrontendController],
    providers: [
        SiteFrontendService,
        AuthService,
        JwtHelper,
        MailSenderService,
        RetailerService,
        AlpineiqService
    ]
})
export class SiteFrontendModule {
}
